﻿Type=Class
Version=7.01
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Event: Response(Response as int, Signature as bitmap)
#RaisesSynchronousEvents: BMsgBox3_Click

Sub Class_Globals
	Public Response As Int = 100
	Public Sign As Bitmap
	Public ColoreStyle As Int = Colors.RGB(121,179,228)
	
	Private IsInitialized As Boolean = False
	Private My As Activity
	Private Pan As Panel
	Private Box As Panel
	Private CallBack As Object
	Private Event As String
	
	Private Image As Label
	Private TimerCount As Int
	Private TimeStart As Long
	Private TimeEnd As Long
	
	Private PanelFirma As Panel
	Private Firma As Canvas
	Private px,py As Int
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(MyActivity As Activity, Me_CallBack As Object,EventName As String)
	My=MyActivity
	CallBack=Me_CallBack
	Event=EventName
	IsInitialized=True
	Sign=Null
End Sub

#Region Grafic Support

private Sub PanelMsgBox3_Touch (Action As Int, X As Float, Y As Float)
	Dim P As Phone
	
	P.HideKeyboard(My)
End Sub

Private Sub Corner(Colore As Int) As ColorDrawable
	Dim cdb As ColorDrawable
	cdb.Initialize(Colore, 20dip)
	Return cdb
End Sub

Private Sub Underline(Colore As Int, ColoreLinea As Int, Down As Boolean) As Bitmap
	Dim Bm As Bitmap
	Dim Can As Canvas
	
	Bm.InitializeMutable(300dip,200dip)
	Can.Initialize2(Bm)
	Can.DrawColor(Colore)
	If Down Then Can.DrawLine(0dip,198dip,300dip,198dip,ColoreLinea,2dip) Else Can.DrawLine(0dip,0dip,300dip,0dip,ColoreLinea,2dip)
	Return Bm
End Sub

#End Region

#Region Box
'-100 Error not initialized
Sub Show(Title As String, Positive As String, Negative As String)
	Dim Larghezza As Int = 300dip
	Dim LBu3 As Int = (Larghezza-40dip)/3
	
	If IsInitialized Then
		Pan.Initialize("PanelMsgBox3")
		Pan.Color=Colors.ARGB(210,10,10,10)
		My.AddView(Pan,0dip,0dip,100%x,100%y)
		
		Box.Initialize("Box")
		Box.Tag=""
		'Box.Color=Colors.White
		Box.Background=Corner(Colors.White)
		Pan.AddView(Box,50%x-Larghezza/2,50%y-150dip,Larghezza,300dip)
		
		Dim L As Label
		L.Initialize("")
		L.SetBackgroundImage(Underline(Colors.White,Colors.DarkGray,True))
		L.Textcolor=Colors.Black
		L.Gravity=Gravity.CENTER
		L.TextSize=18
		L.Typeface=Typeface.DEFAULT_BOLD
		L.Text=Title
		Box.AddView(L,20dip,0dip,Larghezza-40dip,50dip)
		
		PanelFirma.Initialize("PanelFirma")
		Box.AddView(PanelFirma,20dip,50dip,Larghezza-40dip,180dip)
		Firma.Initialize(PanelFirma)
		Firma.DrawColor(Colors.White)
'		Dim obj As Reflector
'		obj.Target = PanelFirma
'		obj.SetOnTouchListener("PanelFirma_Touch")

		Dim ResPanel As Panel
		ResPanel.Initialize("")
		ResPanel.SetBackgroundImage(Underline(Colors.White,Colors.DarkGray,False))
		Box.AddView(ResPanel,20dip,240dip,Larghezza-40dip,60dip)
		
		Dim BPositive, BCancel, BNegative As Button
		If Positive.Trim<>"" Then
			BPositive.Initialize("BMsgBox3")
			BPositive.Text=Positive
			BPositive.Gravity=Gravity.CENTER
			BPositive.TextColor=Colors.Black
			BPositive.Typeface=Typeface.DEFAULT_BOLD
			'BPositive.Background=Corner(ColoreStyle)
			BPositive.Color=Colors.Transparent
			BPositive.Tag=DialogResponse.POSITIVE
			Box.AddView(BPositive,10dip,240dip,LBu3,60dip)
		End If
	
		If Negative.Trim<>"" Then
			BNegative.Initialize("BMsgBox3")
			BNegative.Text=Negative
			BNegative.Gravity=Gravity.CENTER
			BNegative.TextColor=Colors.Black
			BNegative.Typeface=Typeface.DEFAULT_BOLD
			'BNegative.Background=Corner(ColoreStyle)
			BNegative.Color=Colors.Transparent
			BNegative.Tag=DialogResponse.NEGATIVE
			Box.AddView(BNegative,Larghezza-LBu3-10dip,240dip,LBu3,60dip)
		End If
	
		BCancel.Initialize("BMsgBox3")
		BCancel.Text="RESET"
		BCancel.Gravity=Gravity.CENTER
		BCancel.TextColor=Colors.Black
		BCancel.Typeface=Typeface.DEFAULT_BOLD
		'BCancel.Background=Corner(ColoreStyle)
		BCancel.Color=Colors.Transparent
		BCancel.Tag=DialogResponse.CANCEL
		Box.AddView(BCancel,20dip+LBu3,240dip,LBu3,60dip)
		
		Image.Initialize("")
		Image.RemoveView
		Image.TextColor=Colors.Black
		Image.Gravity=Gravity.CENTER
		Image.TextSize=16
		Box.AddView(Image,Box.Width-45dip,5dip,40dip,40dip)
	Else
		ToastMessageShow("MessageBox not initialized",False)
	End If

End Sub

'Private Sub PanelFirma_Touch (viewtag As Object, action As Int, X As Float, Y As Float, motionevent As Object) As Boolean
	Private Sub PanelFirma_Touch (Action As Int, X As Float, Y As Float)
		
	If Action = 0 Then 'mouse down constant
		px = x
		py = y
	Else
		Firma.DrawLine(px, py, x, y, Colors.Black, 3dip)
		PanelFirma.Invalidate
		px = x
		py = y
	End If
	Return True
End Sub

#End Region

#Region Response

Private Sub BMsgBox3_Click
	Dim B As Button = Sender
	Dim R As Int = B.Tag
	
	If R=DialogResponse.CANCEL Then 
		Firma.DrawColor(Colors.White)
		PanelFirma.Invalidate
	Else
		Response=B.Tag
		If Response=DialogResponse.POSITIVE Then Sign=Firma.Bitmap
		Pan.RemoveView
		If SubExists(CallBack,Event & "_Response") Then	CallSub3(CallBack,Event & "_Response",Response,Sign)
	End If
End Sub

Public Sub DoEventWaitResponse As Int
	Dim Tit As Int = GetDeviceLayoutValues.Height - 100%y
	Response=100
	
	If IsInitialized Then
		Do While Response=100
			DoEvents
			If Pan.Width<>GetDeviceLayoutValues.Width  Then
				My.Width=GetDeviceLayoutValues.Width
				My.Height=GetDeviceLayoutValues.Height-Tit
				Pan.Width=GetDeviceLayoutValues.Width
				Pan.Height=GetDeviceLayoutValues.Height-Tit
		
				If Pan.Height>Pan.Width Then
					'verticale -250 +280 = 530
					Log(Pan.Width-Box.Width)
					Box.Left=(Pan.Width-Box.Width)/2
					Box.Top=Pan.Height/2-150dip
				Else
					'orizzontale
					Box.Left=(Pan.Width-Box.Width)/2
					Box.Top=Pan.Height/2-150dip
				End If
			End If
		Loop
	Else
		ToastMessageShow("MsbBox not initialized",False)
		Response=-100
	End If
	Return Response
End Sub

#End Region

#Region TimerDIalog

Sub TimerDialog(MillSec As Int)
	Dim T As Timer
	
	TimeStart=DateTime.Now
	TimeEnd=TimeStart+MillSec
	TimerCount=MillSec/DateTime.TicksPerSecond
	T.initialize("TimerDialog",300)
	T.Enabled=True
End Sub

Private Sub TimerDialog_Tick
	Dim T As Long = DateTime.Now
	Dim TC As Long =(TimeEnd-t)/DateTime.TicksPerSecond
	
	If TC<>TimerCount Then
		'aggiorna GUI
		TimerCount=TC
		Image.Text=TimerCount
		LoadDrawableByName(Image,"spinner_black_48")
		Image.Invalidate
	End If
	If T>=TimeEnd Then
		Dim Ti As Timer = Sender
		Ti.Enabled=False
		
		Response=DialogResponse.CANCEL
		Pan.RemoveView
		If SubExists(CallBack,Event & "_Response") Then CallSub2(CallBack,Event & "_Response",Response)
	End If
End Sub

Private Sub LoadDrawableByName(Control As View, ImageName As String) As Boolean
	Dim R As Reflector
	Try
		R.Target = R.GetContext
		R.Target = R.RunMethod("getResources")
		R.Target = R.RunMethod("getSystem")
		Dim ID_Drawable As Int
		ID_Drawable = R.RunMethod4("getIdentifier", Array As Object(ImageName, "drawable", "android"), _
		                                            Array As String("java.lang.String", "java.lang.String", "java.lang.String"))
		R.Target = R.GetContext
		R.Target = R.RunMethod("getResources")
		Control.Background = R.RunMethod2("getDrawable", ID_Drawable, "java.lang.int")
		Return True
		
	Catch
		LogColor("ERROR.LoadDrawableByName:" & LastException.Message, Colors.Red)
		Return False
	End Try
End Sub

#End Region
